\ (C) 1995 JOHNS HOPKINS UNIVERSITY/APPLIED PHYSICS LABORATORY
\     MAY BE DISTRIBUTED FREELY AS LONG AS THIS COPYRIGHT
\     NOTICE REMAINS.

\ MM-190108  adapted for 430eForth43n4vis
\ MM-210409  changed to lower case for 430eForth43n7vis

decimal

#ifndef 1-  : 1- 1 - ;
#ifndef I   : I r> r@ swap >r ;


variable #results
create results 12 2* allot

: showres   ( -- 1 )
   #results @ ?dup if
      1- dup for dup I - 2* results + ? next drop
   then 1 ;
: T{   ( -- ) ;
: ->   ( ... -- )
   \ save stack depth and result values
   depth dup #results !
   ?dup if
     1- for results I 2* + ! next
   then ;
: }T   ( ... -- )
   \ compare saved results with expected values on stack
   depth #results @ = if
      depth ?dup if
         1- for results I 2* + @ = while next
         else r> drop showres ABORT"  INCORRECT RESULT" then
      then
   else
      showres ABORT" WRONG NUMBER OF results"
   then ;

\\ MM-190108

\ minimal output string test facility
\ tests (chars-count) (chars-sum mod 2^16)
\ usage e.g. T{e WORDS e-> 1005 1916 }T
variable Char#
variable CharSum
variable EmitV 'EMIT @ EmitV !

: tEmit ( c -- )
   1 Char# +!  CharSum +! ;
: T{e ( -- )
   [ ' tEmit ] LITERAL 'EMIT !
   0 Char# ! 0 CharSum ! ;
: e-> ( -- n n )
   EmitV @ 'EMIT !
   Char# @ CharSum @ -> ;
